// 
// This only works for ATMega328-compatibles; ie, Leonardo is not covered here.
// Library for the RC  (PinChangeInt): http://code.google.com/p/arduino-pinchangeint/wiki   
// inspiration for driving the Chinese music box is from tardate/Paul Gallagher and his blog http://blog.tardate.com/2017/01/littlearduinoprojects226-music-box.html


// by Ellipsis  - 2017



#include <PinChangeInt.h>

// Modify these at your leisure

//inputs for RC channeles
#define MYPIN1 A0 //RC channel 

//outputs for switches
int switchA = 4;  //switch A
int switchB = 5;  //switch B
int switchC = 6;  //switch C
int switchD = 7;  //switch D


volatile int nThrottleIn1 = 0; 

volatile unsigned long ulStartPeriod1 = 0;

volatile boolean bNewThrottleSignal = false; 


//SWITCHES coding   (0=LOW   1=HIGH)
// A B C D 	Sound
// 0 0 0 0	Machine gun voice
// 0 0 0 1	Fire truck voice
// 0 0 1 0	Ambulance voice
// 0 0 1 1	The police car voice
// 0 1 0 0	Crickets sound
// 0 1 0 1	alarm
// 0 1 1 0	Electronic signal sound
// 0 1 1 1	koh
// 1 0 0 0	Insect song
// 1 0 0 1	whistle
// 1 0 1 0	Telegraph sound
// 1 0 1 1	Bird song
// 1 1 0 0	ChongJi gunfire
// 1 1 0 1	Car sirens
// 1 1 1 0	Bass instruments sound
// 1 1 1 1	Racing sound



//################################################################


// Attach the interrupts in setup()
void setup() {
  pinMode(MYPIN1, INPUT_PULLUP);
  attachPinChangeInterrupt(MYPIN1, calcInput1, CHANGE); //A0
 
  
 
  pinMode(switchA, OUTPUT); // initialize the digital pin (4) as an output
  pinMode(switchB, OUTPUT); // initialize the digital pin (5) as an output.
  pinMode(switchC, OUTPUT); // initialize the digital pin (6) as an output.
  pinMode(switchD, OUTPUT); // initialize the digital pin (7) as an output.
  
 // need to be uncommented if you would like to see RC channel values
 // Serial.begin(115200);
 // Serial.println("---------------------------------------");
}


//################################################################
void loop() {
 
if(bNewThrottleSignal){

// If you would like to see values for the each RC channel - pls uncomment all below lines
//   Serial.println(nThrottleIn1);

if (nThrottleIn1>1600)
{
  siren(random(1,6)); 		//randomly selects the sound from 5 different
  delay(random(1300,4500));     //length of played sound from 1,3 sec to 4,5 sec
  {digitalWrite(switchA, LOW);}
  {digitalWrite(switchB, LOW);}
  {digitalWrite(switchC, LOW);}
  {digitalWrite(switchD, LOW);}
}
if (nThrottleIn1<1600)
{
  {digitalWrite(switchA, LOW);}
  {digitalWrite(switchB, LOW);}
  {digitalWrite(switchC, LOW);}
  {digitalWrite(switchD, LOW);}
}



}
bNewThrottleSignal = false;
}

//################################################################

// Do not use any Serial.print() in interrupt subroutines. Serial.print() uses interrupts,
// and by default interrupts are off in interrupt subroutines.

//################################################################
void calcInput1()
{
  if(digitalRead(MYPIN1) == HIGH)
  { 
    ulStartPeriod1 = micros();
  }
  else
  {
    if(ulStartPeriod1 && (bNewThrottleSignal == false))
    {
      nThrottleIn1 = (int)(micros() - ulStartPeriod1);
      ulStartPeriod1 = 0;
      bNewThrottleSignal = true;
    }
  }
}
//################################################################
void siren(byte liczba)
{
switch (liczba){
  case 1:
  {
  // 0 0 0 1  Fire truck voice
      digitalWrite(switchD, HIGH);
  }
  break;
  
  case 2:
  {
    // 0 0 1 0  Ambulance voice
    {digitalWrite(switchC, HIGH);}
  }
  break;
  case 3:
  {
    // 0 0 1 1  The police car voice
    {digitalWrite(switchC, HIGH);}
    {digitalWrite(switchD, HIGH);}
  }
  break;
  case 4:
  {
    // 0 1 0 1  alarm
    {digitalWrite(switchB, HIGH);}
    {digitalWrite(switchD, HIGH);}
  }
  break;
  case 5:
  {
    // 1 0 0 1  whistle
    {digitalWrite(switchA, HIGH);}
    {digitalWrite(switchD, HIGH);}
  }
  break;
  
}

}
//################################################################

